Welcome to Subscribe On Youtube

Question

Formatted question description: https://leetcode.ca/all/351.html

Android devices have a special lock screen with a 3 x 3 grid of dots. Users can set an "unlock pattern" by connecting the dots in a specific sequence, forming a series of joined line segments where each segment's endpoints are two consecutive dots in the sequence. A sequence of k dots is a valid unlock pattern if both of the following are true:

  • All the dots in the sequence are distinct.
  • If the line segment connecting two consecutive dots in the sequence passes through the center of any other dot, the other dot must have previously appeared in the sequence. No jumps through the center non-selected dots are allowed.
    • For example, connecting dots 2 and 9 without dots 5 or 6 appearing beforehand is valid because the line from dot 2 to dot 9 does not pass through the center of either dot 5 or 6.
    • However, connecting dots 1 and 3 without dot 2 appearing beforehand is invalid because the line from dot 1 to dot 3 passes through the center of dot 2.

Here are some example valid and invalid unlock patterns:

  • The 1st pattern [4,1,3,6] is invalid because the line connecting dots 1 and 3 pass through dot 2, but dot 2 did not previously appear in the sequence.
  • The 2nd pattern [4,1,9,2] is invalid because the line connecting dots 1 and 9 pass through dot 5, but dot 5 did not previously appear in the sequence.
  • The 3rd pattern [2,4,1,3,6] is valid because it follows the conditions. The line connecting dots 1 and 3 meets the condition because dot 2 previously appeared in the sequence.
  • The 4th pattern [6,5,4,1,9,2] is valid because it follows the conditions. The line connecting dots 1 and 9 meets the condition because dot 5 previously appeared in the sequence.

Given two integers m and n, return the number of unique and valid unlock patterns of the Android grid lock screen that consist of at least m keys and at most n keys.

Two unlock patterns are considered unique if there is a dot in one sequence that is not in the other, or the order of the dots is different.

 

Example 1:

Input: m = 1, n = 1
Output: 9

Example 2:

Input: m = 1, n = 2
Output: 65

 

Constraints:

  • 1 <= m, n <= 9

Algorithm

Let’s take a look at what is illegal,

  • First, 1 cannot go directly to 3, it must go through 2.
  • For the same reason, there are 4 to 6, 7 to 9, 1 to 7, 2 to 8, 3 to 9,
  • There are also diagonals that must pass through 5, such as 1 to 9, 3 to 7, etc.

Create a two-dimensional array jumps to record whether there is an intermediate key between the two number keys,

Then use a one-bit array visited to record whether a key has been visited.

Then use recursion to solve. First call the recursive function for 1, in the recursive function, traverse each number from 1 to 9 next, and then find if there is a jump between them.

If next has not been visited, and jump is 0. Or jump has been visited. Call the recursive function to next.

  • After the number of patterns of number 1 is calculated, since 1,3,7,9 are symmetrical, multiply by 4
  • Then call the recursive function on the number 2.
    • 2, 4, 6, 9 are also symmetrical, and then multiply by 4.
  • Finally, call 5 separately, and then add up all of them to get the final result.

Code

  • 
    public class Android_Unlock_Patterns {
    
        public class Solution_4multiply {
    
            public int numberOfPatterns(int m, int n) {
                int res = 0;
                boolean[] visited = new boolean[10];
                int[][] jumps = new int[10][10]; // record whether there is an intermediate key between the two number keys
                jumps[1][3] = jumps[3][1] = 2;
                jumps[4][6] = jumps[6][4] = 5;
                jumps[7][9] = jumps[9][7] = 8;
                jumps[1][7] = jumps[7][1] = 4;
                jumps[2][8] = jumps[8][2] = 5;
                jumps[3][9] = jumps[9][3] = 6;
                jumps[1][9] = jumps[9][1] = jumps[3][7] = jumps[7][3] = 5;
                res += dfs(1, 1, m, n, jumps, visited, 0) * 4;
                res += dfs(2, 1, m, n, jumps, visited, 0) * 4;
                res += dfs(5, 1, m, n, jumps, visited, 0);
                return res;
            }
    
            int dfs(int num, int len, int m, int n, int[][] jumps, boolean[] visited, int res) {
                if (len >= m) ++res;
                ++len;
                if (len > n) return res;
                visited[num] = true;
                for (int next = 1; next <= 9; ++next) {
                    int jump = jumps[num][next];
                    if (!visited[next] && (jump == 0 || visited[jump])) {
                        res = dfs(next, len, m, n, jumps, visited, res);
                    }
                }
                visited[num] = false;
                return res;
            }
        }
    
    
        // below is dfs to check every possible, with no multiplied-4 optimization
        public class Solution {
    
            private int patterns;
    
            public int numberOfPatterns(int m, int n) {
    
                boolean[] isVisited = new boolean[10];
    
                for (int i = 1; i <= 9; i++) {
                    isVisited[i] = true;
                    find(isVisited, i, 1, m, n);
                    isVisited[i] = false;
                }
    
                return patterns;
            }
    
            private void find(boolean[] isVisited, int from, int currentStep, int m, int n) {
                if (currentStep == n) {
                    patterns++;
                    return;
                }
                if (currentStep >= m) {
                    patterns++;
                }
    
                for (int i = 1; i <= 9; i++) {
                    if (isValid(isVisited, from, i)) {
                        isVisited[i] = true;
                        find(isVisited, i, currentStep + 1, m, n);
                        isVisited[i] = false;
                    }
                }
            }
    
            // core is this function, for check logic
            private boolean isValid(boolean[] isVisited, int from, int to) {
                if (from == to) {
                    return false;
                }
    
                int i = Math.min(from, to);
                int j = Math.max(from, to);
    
                if ((i == 1 && j == 9) || (i == 3 && j == 7)) {
                    return isVisited[5] && !isVisited[to];
                }
                if ((i == 1 || i == 4 || i == 7) && i + 2 == j) {
                    return isVisited[i + 1] && !isVisited[to];
                }
                if (i <= 3 && i + 6 == j) {
                    return isVisited[i + 3] && !isVisited[to];
                }
    
                return !isVisited[to];
            }
        }
    }
    
  • class Solution(object):
      def numberOfPatterns(self, m, n):
        """
        :type m: int
        :type n: int
        :rtype: int
        """
    
        def dfs(m, n, prev, visited, length):
          if m <= length <= n:
            self.ans += 1
    
          if length == n:
            return
    
          for i in range(1, 10):
            if i not in visited:
              x, y, xp, yp = (i - 1) / 3, (i - 1) % 3, (prev - 1) / 3, (prev - 1) % 3
              if (5 not in visited and (x + xp, y + yp) == (2, 2)) or (
                (x == xp and abs(y - yp) == 2) or (y == yp and abs(x - xp) == 2)) and (prev + i) / 2 not in visited:
                continue
              visited |= {i}
              dfs(m, n, i, visited, length + 1)
              visited.discard(i)
    
        visited = set()
        self.ans = 0
        dfs(m, n, -99, visited, 0)
        return self.ans
    
    
  • class Solution {
    public:
        int numberOfPatterns(int m, int n) {
            int cross[10][10];
            memset(cross, 0, sizeof(cross));
            bool vis[10];
            memset(vis, false, sizeof(vis));
            cross[1][3] = cross[3][1] = 2;
            cross[1][7] = cross[7][1] = 4;
            cross[1][9] = cross[9][1] = 5;
            cross[2][8] = cross[8][2] = 5;
            cross[3][7] = cross[7][3] = 5;
            cross[3][9] = cross[9][3] = 6;
            cross[4][6] = cross[6][4] = 5;
            cross[7][9] = cross[9][7] = 8;
    
            function<int(int, int)> dfs = [&](int i, int cnt) {
                if (cnt > n) {
                    return 0;
                }
                vis[i] = true;
                int ans = cnt >= m ? 1 : 0;
                for (int j = 1; j < 10; ++j) {
                    int x = cross[i][j];
                    if (!vis[j] && (x == 0 || vis[x])) {
                        ans += dfs(j, cnt + 1);
                    }
                }
                vis[i] = false;
                return ans;
            };
    
            return dfs(1, 1) * 4 + dfs(2, 1) * 4 + dfs(5, 1);
        }
    };
    
  • func numberOfPatterns(m int, n int) int {
    	cross := [10][10]int{}
    	vis := [10]bool{}
    	cross[1][3] = 2
    	cross[1][7] = 4
    	cross[1][9] = 5
    	cross[2][8] = 5
    	cross[3][7] = 5
    	cross[3][9] = 6
    	cross[4][6] = 5
    	cross[7][9] = 8
    	cross[3][1] = 2
    	cross[7][1] = 4
    	cross[9][1] = 5
    	cross[8][2] = 5
    	cross[7][3] = 5
    	cross[9][3] = 6
    	cross[6][4] = 5
    	cross[9][7] = 8
    	var dfs func(int, int) int
    	dfs = func(i, cnt int) int {
    		if cnt > n {
    			return 0
    		}
    		vis[i] = true
    		ans := 0
    		if cnt >= m {
    			ans++
    		}
    		for j := 1; j < 10; j++ {
    			x := cross[i][j]
    			if !vis[j] && (x == 0 || vis[x]) {
    				ans += dfs(j, cnt+1)
    			}
    		}
    		vis[i] = false
    		return ans
    	}
    	return dfs(1, 1)*4 + dfs(2, 1)*4 + dfs(5, 1)
    }
    
  • function numberOfPatterns(m: number, n: number): number {
        const cross: number[][] = Array(10)
            .fill(0)
            .map(() => Array(10).fill(0));
        const vis: boolean[] = Array(10).fill(false);
        cross[1][3] = cross[3][1] = 2;
        cross[1][7] = cross[7][1] = 4;
        cross[1][9] = cross[9][1] = 5;
        cross[2][8] = cross[8][2] = 5;
        cross[3][7] = cross[7][3] = 5;
        cross[3][9] = cross[9][3] = 6;
        cross[4][6] = cross[6][4] = 5;
        cross[7][9] = cross[9][7] = 8;
        const dfs = (i: number, cnt: number): number => {
            if (cnt > n) {
                return 0;
            }
            vis[i] = true;
            let ans = 0;
            if (cnt >= m) {
                ++ans;
            }
            for (let j = 1; j < 10; ++j) {
                const x = cross[i][j];
                if (!vis[j] && (x === 0 || vis[x])) {
                    ans += dfs(j, cnt + 1);
                }
            }
            vis[i] = false;
            return ans;
        };
        return dfs(1, 1) * 4 + dfs(2, 1) * 4 + dfs(5, 1);
    }
    
    

All Problems

All Solutions